local basic = require("lib.basic")

--secure digging wrappers
local function secureDig()
  while turtle.detect() do 
    turtle.dig() 
  end
end
local function secureDigUp()
  while turtle.detectUp() do 
    turtle.digUp() 
  end
end
local function secureDigDown()
  while turtle.detectDown() do 
    turtle.digDown() 
  end
end



--location returning move wrapper
--https://www.youtube.com/watch?v=bZe5J8SVCYQ

local pos = {}

local function savePos()
  basic.writeToFile("brulijam/files/pos.txt", textutils.serialize(pos))
end

local function getPos()
  if not fs.exists "brulijam/files/pos.txt" then
    basic.clearDisplay()
    print("[Postion init]")

    write("x: ")
    x = tonumber(read())
    write("y: ")
    y = tonumber(read())
    write("z: ")
    z = tonumber(read())
    write("r (S=0,W=1,N=2,E=3):")
    r = tonumber(read())
    basic.clearDisplay()

    pos["x"] = x
    pos["y"] = y
    pos["z"] = z
    pos["r"] = r
    basic.writeToFile("brulijam/files/pos.txt", textutils.serialize(pos))
  else
    pos = basic.readFileAll("brulijam/files/pos.txt")
    pos = textutils.unserialize(pos)
  end
  return pos
end

local function forward()
  if turtle.forward() then
    pos = getPos()
    sleep(0.2)
    if pos["r"] == 0 then
      pos["z"] = pos["z"] + 1
    elseif pos["r"] == 1 then
      pos["x"] = pos["x"] - 1
    elseif pos["r"] == 2 then
      pos["z"] = pos["z"] - 1
    elseif pos["r"] == 3 then
      pos["x"] = pos["x"] + 1
    end
    savePos()
  end
end

local function back()
  sleep(0.2)
  if turtle.back() then
    if pos["r"] == 0 then
      pos["z"] = pos["z"] - 1
    elseif pos["r"] == 1 then
      pos["x"] = pos["x"] + 1
    elseif pos["r"] == 2 then
      pos["z"] = pos["z"] + 1
    elseif pos["r"] == 3 then
      pos["x"] = pos["x"] - 1
    end
    savePos()
  end
end

local function up()
  sleep(0.2)
  if turtle.up() then
    pos["y"] = pos["y"] + 1
    savePos()
  end
end

local function down()
  sleep(0.2)
  if turtle.down() then
    pos["y"] = pos["y"] - 1
    savePos()
  end
end

local function left()
  sleep(0.2)
  if turtle.turnLeft() then
    pos["r"] = (pos["r"]-1) % 4
    savePos()
  end
end

local function right()
  sleep(0.2)
  if turtle.turnRight() then
    pos["r"] = (pos["r"]+1) % 4
    savePos()
  end
end




local function goToPosition(toR, toX, toY, toZ)
  print("t1")
  -- go to lastValidY
  while pos["y"] < toY do
    secureDigUp()
    up()
  end
  while pos["y"] > toY do
    secureDigDown()
    down()
  end

  --go to lastValidX
  while pos["x"] < toX do
    while not pos["r"] == 3 do
      right()
    end
    secureDig()
    forward()
  end
  while pos["x"] > toX do
    while not pos["r"] == 1 do
      right()
    end
    secureDig()
    forward()
  end

  --go to lastValidZ
  while pos["z"] < toZ do
    while not pos["r"] == 0 do
      right()
    end
    secureDig()
    forward()
  end
  while pos["z"] > toZ do
    while not pos["r"] == 2 do
      right()
    end
    secureDig()
    forward()
  end

  --rotate in right direction
  while not pos["r"] == toR do
    right()
  end
end




return
{
  secureDig=secureDig,
  secureDigUp=secureDigUp,
  secureDigDown=secureDigDown,
  forward=forward,
  back=back,
  up=up,
  down=down,
  left=left,
  right=right,
  getPos=getPos,
  goToPosition=goToPosition,
}